Main Page Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members Related Pages

# DeviceInterfaceI Class Reference

Device interface. More...

`#include <DeviceInterfaceI.h>`

Inheritance diagram for DeviceInterfaceI:

List of all members.

## Public Member Functions
virtual PluginClass::SuperClassIdC | get_super_class_id () const=0
| Returns super class ID.
virtual PluginClass::ClassIdC | get_class_id () const=0
| Returns class ID.
virtual const char * | get_class_name ()=0
| Returns device's class name as NULL terminated string.
virtual bool | get_exclusive () const
| Returns true if device is exclusive.
virtual PajaTypes::uint32 | get_state () const
| Returns device state, See also: DeviceStateE.
virtual void | set_state (PajaTypes::uint32 ui32State)
| Sets device state, See also: DeviceStateE.
virtual PajaSystem::DeviceInterfaceI * | query_interface (const PluginClass::SuperClassIdC &rSuperClassId)
| Extends device functionality, default implementation returns NULL.
virtual PajaTypes::uint32 | save (FileIO::SaveC *pSave)=0
| Serialize device settings to a Demopaja output stream.
virtual PajaTypes::uint32 | load (FileIO::LoadC *pLoad)=0
| Serialize device settings from a Demopaja input stream.
## Protected Member Functions
| DeviceInterfaceI ()
| Default constructor.
virtual | ~DeviceInterfaceI ()
| Default destructor.
## Protected Attributes
PajaTypes::uint32 | m_ui32State

## Detailed Description

Device interface.

Device interface is the base class interface for all devices the effects in Demopaja system can use.

## Constructor & Destructor Documentation

DeviceInterfaceI | ( |  | ) | `[protected]`

| Default constructor.

virtual ~DeviceInterfaceI | ( |  | ) | `[protected, virtual]`

| Default destructor.

## Member Function Documentation

virtual PluginClass::ClassIdC get_class_id | ( |  | ) | const`[pure virtual]`

| Returns class ID. Implemented in OpenGLBufferC, and OpenGLViewportC.

virtual const char* get_class_name | ( |  | ) | `[pure virtual]`

| Returns device's class name as NULL terminated string. Implemented in OpenGLBufferC, and OpenGLViewportC.

virtual bool get_exclusive | ( |  | ) | const`[virtual]`

| Returns true if device is exclusive. Exclusive device means that there can be only one device of this superclass in the device context. Default implementation returns false. Reimplemented in GraphicsDeviceI.

virtual PajaTypes::uint32 get_state | ( |  | ) | const`[virtual]`

| Returns device state, See also: DeviceStateE.

virtual PluginClass::SuperClassIdC get_super_class_id | ( |  | ) | const`[pure virtual]`

| Returns super class ID. Implemented in GraphicsBufferI, GraphicsDeviceI, GraphicsViewportI, and GUIDrawInterfaceI.

virtual PajaTypes::uint32 load | ( | FileIO::LoadC * | pLoad | ) | `[pure virtual]`

| Serialize device settings from a Demopaja input stream. Implemented in GraphicsBufferI, GraphicsViewportI, and GUIDrawInterfaceI.

virtual PajaSystem::DeviceInterfaceI* query_interface | ( | const PluginClass::SuperClassIdC & | rSuperClassId | ) | `[virtual]`

| Extends device functionality, default implementation returns NULL. Reimplemented in OpenGLBufferC.

virtual PajaTypes::uint32 save | ( | FileIO::SaveC * | pSave | ) | `[pure virtual]`

| Serialize device settings to a Demopaja output stream. Implemented in GraphicsBufferI, GraphicsViewportI, and GUIDrawInterfaceI.

virtual void set_state | ( | PajaTypes::uint32 | ui32State | ) | `[virtual]`

| Sets device state, See also: DeviceStateE.